#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <pthread.h>

#define checkError(expr,userMsg)\
    do {\
        if (!(expr)) {\
            perror(userMsg);\
            exit(EXIT_FAILURE);\
        }\
    } while(0)
// #define checkErrorPthread(err,userMsg) \
//     do {\
//         int _err = err;\
//         if (_err > 0) { \
//             errno = _err;\
//             perror(userMsg);\
//             exit(EXIT_FAILURE);\
//         } \
//     } while(0);

#define checkErrorPthread(err,userMsg) \
    do {\
        int _err = err;\
        if (_err > 0) { \
            errno = _err;\
            checkError(0,userMsg);\
        } \
    } while(0);

typedef struct {
    int data;
} InputData_t;

typedef struct {
    int data;
} OutputData_t;

void* threadFunc(void* arg) {

    InputData_t* data = (InputData_t*)arg;

    printf("Thread: %d\n", data->data);

    OutputData_t* out = malloc(sizeof(OutputData_t));
    checkError(out != NULL, "malloc");
    out->data = data->data*data->data;

    return (void*)out;
    // pthread_exit(out);
}

int main(int argc, char** argv) {

    checkError(argc == 2, "args");

    int n = atoi(argv[1]);
    pthread_t* tids = malloc(n*sizeof(pthread_t));
    checkError(tids != NULL, "malloc");

    InputData_t* data = malloc(n*sizeof(InputData_t));
    checkError(data != NULL, "malloc");

    for (int i = 0; i < n; i++) {
        data[i].data = i + 1;
        checkErrorPthread(
            pthread_create(&tids[i], NULL, threadFunc, &data[i]),
            "create");
    }

    for (int i = 0; i < n; i++) {
        OutputData_t* outData = NULL;
        checkErrorPthread(
        pthread_join(tids[i], (void**)&outData),
        "join");
        printf("Thread ended: %d\n", outData->data);
        free(outData);
    }

    free(tids);
    free(data);

    exit(EXIT_SUCCESS);
}